// buildui.js


function addMenuBufferItem() {
    var menuList = document.getElementById('menu-document-list');
    var menuPopup = document.getElementById('menu-buffer-popup');
    var menuItem = document.createElement('menuitem');
    var x = BufferList.list.length;

    menuItem.setAttribute('label',x+' Untitled');
    menuItem.setAttribute('oncommand','doBuff('+x+')');
    menuItem.setAttribute('id','buffer-item'+x);
    menuItem.setAttribute('accesskey',x);
    menuPopup.appendChild(menuItem);
    tempBuffer = new Buffer("","");
    buffer.saveBuffer(content.value, inputFile.value);
    bufferList.addBuffer( tempBuffer );
    buffer = tempBuffer;
    content.value = "";
    buffer.setIsChanged(false);
    inputFile.value = "";
    setWindowTitle(inputFile.value);
    refreshSidebar();
    updateStatus("Buffer created..");
    dump("Buffer created in addMenuBufferItem()\n");
}



function removeMenuBufferItem(which) {
    if ( isSaveNagEnabled == "true" && content.value != "" && buffer.getIsChanged() == true ) {
        if (doSaveConfirmation() == false) {
            return;
        }
    }

   if (which == null) {
     which = BufferList.currentBuffer;
   }

    buffer.saveBuffer(content.value, inputFile.value);
    buildBufferMenu();
    setWindowTitle();
    refreshPreview();

    bufferList.removeBuffer(which);
    buffer = bufferList.getBuffer(BufferList.currentBuffer);
    var modified = buffer.getIsChanged();
    content.value = buffer.getContent();
    inputFile.value = buffer.getInput();
    setModifiedState( modified );
    setWindowTitle(inputFile.value);
    buildBufferMenu();
    refreshPreview();
    refreshSidebar();
    updateStatus("Buffer killed..");
}


function removeMenuBufferAllItems() {
     if (checkAllBuffersForChange() == false) {
         return;
     }
     buffer = new Buffer("","");
     inputFile.value = "";
     content.value = "";
     bufferList = new BufferList();
     bufferList.addBuffer( buffer );
     buildBufferMenu();
     setWindowTitle();
     updateStatus("All buffers killed..");
}


function buildViewMenuChecks() {
    var menuItems = [ "view-icons","view-location","view-tabs","view-editor","view-execute",
    "view-status-bar","view-tags-bar","view-browser","view-js-console","view-side-bar","view-symbols" ];

    var toolbarItems = [ "icon-toolbar","addressbar","tab-bar","content-editor","execute-command",
    "status-toolbox","tags-bar","browser-preview","javascript-console","mozedit-sidebar","symbols" ];


    for (x=0; x < menuItems.length; x++) {
        var iconItem = document.getElementById(menuItems[x]);
        var iconBar = document.getElementById(toolbarItems[x]);

        if (iconBar.getAttribute('collapsed').search(/false/) != -1 || iconBar.getAttribute('hidden').search(/false/) != -1) {
            iconItem.setAttribute('checked','true');
        } else {
            iconItem.setAttribute('checked','false');
        }
    }
}

function buildEditor() {
     // editor pane
     var box = document.getElementById('editor-box');
     var editor = document.createElement('textbox');
     dump("editor is set to: " + editorBindings + " in buildui.js:buildEditor()\n");
     editor.setAttribute('collapsed','false');
     editor.setAttribute('persist', 'state collapsed');
     editor.setAttribute('class', editorBindings);
     editor.setAttribute('multiline', 'true');
     editor.setAttribute('oninput', 'setModifiedState(true);');
     editor.setAttribute('flex', '1');
     box.appendChild( editor );

     var mode = "emacs";
     if (editorBindings == "editordefault") {
         mode = "default";
     }

     // execute bar
     var box = document.getElementById('execute-box');
     var execute = document.createElement('textbox');
     execute.setAttribute('class', 'execute'+mode);
     execute.setAttribute('flex', '1');
     box.appendChild( execute );

     // location bar
     var box = document.getElementById('location-box');
     var location = document.createElement('textbox');
     location.setAttribute('class', 'location'+mode);
     location.setAttribute('flex', '1');
     box.appendChild( location );
}

function buildBufferMenu() {
    var menuList = document.getElementById('menu-document-list');
    var menuPopup = document.getElementById('menu-buffer-popup');
    var menuPopupNew = document.createElement('menupopup');

    var throwaway = menuList.removeChild(menuPopup);
    menuList.appendChild(menuPopupNew);
    menuPopupNew.setAttribute('id','menu-buffer-popup');

    for (x=0; x < BufferList.list.length; x++) {
        var tempBuffer = bufferList.getBuffer(x);
        var title = truncate( tempBuffer.getInput() );
        var leafname = leaf( tempBuffer.getInput() );
        
        if (title == "") {
            title = x+' Untitled ';
        } else {
            title = x+" "+ leafname + "  " + title;
        }
        var menuItem = document.createElement('menuitem');
        menuItem.setAttribute('label',title);
        menuItem.setAttribute('id','buffer-item'+x);
        menuItem.setAttribute('accesskey',x);
        menuItem.setAttribute('oncommand','doBuff('+x+')');
        menuPopupNew.appendChild(menuItem);
    }
}


// add History menu items
function buildGoMenu() {
    var menuList = document.getElementById('menu-go-list');
    var menuPopup = document.getElementById('menu-go-popup');

    for (x = 0; x < documentHistory.length; x++) {
        if ( documentHistory[x] == "") {
            continue;
        }

        var path = trim(documentHistory[x]);
        if (navigator.platform == "Win32") {
            path = path.replace(/\//g,"\\");
        }

        var menuItem = document.createElement('menuitem');

        menuItem.setAttribute('label',truncate(path));
        menuItem.setAttribute('oncommand',"goToURL(\"" + encodeURI(path) + "\")");
        menuItem.setAttribute('id',"menu-go-item"+x);
        menuPopup.appendChild(menuItem);

        dump("adding: menu-go-item"+x+"\n");
    }
}


// add History menu items
function appendGoMenu(path) {
    if ( documentHistory.length >= historyMax ) {
        documentHistory.shift(); // shorten list if at max

	    try {
            var menuPopup = document.getElementById('menu-go-popup');

            // node 4 is first history item on Go menu
            throwaway_node = menuPopup.removeChild( menuPopup.childNodes[4] );
            dump(throwaway_node+" removed node in appendGoMenu()\n");
        } catch (e) {
		    dump("error in modifying nodes in appendGoMenu()\n");
		}
    }
    documentHistory.push(path);

    dump("documentHistory length in appendGoMenu(): " + documentHistory.length+ "\n");
    var menuPopup = document.getElementById('menu-go-popup');
    var menuItem = document.createElement('menuitem');

    if (navigator.platform == "Win32") {
        path = path.replace(/\//g,"\\");
    }

    pathEncoded = encodeURI(path);
    menuPopup.appendChild(menuItem);
    menuItem.setAttribute('label',truncate(path));
    menuItem.setAttribute('oncommand',"goToURL('" + pathEncoded + "')");
    menuItem.setAttribute('id',"menu-go-item" + documentHistory.length);
    dump("adding: menu-go-item"+documentHistory.length+"\n");
}

function buildSymbolsPopup() {
    var menuPopup = document.getElementById("symbols-popup");

    for (x=33; x <= 255; x++) {
        var menuItem = document.createElement('menuitem');
        var symbol = String.fromCharCode(x);
        menuPopup.appendChild(menuItem);

        menuItem.setAttribute("label",symbol);
        menuItem.setAttribute("oncommand","insertSymbol(" + x + ")");
    }

}

function buildMenuKeyBindings() {
   if ( editorBindings == "editordefault" ) {
       return;
   } else {
       include("chrome://mozedit/content/scripts/emacsbindings.js");
   }

   var keyList = new Array();

   try {
       for (x=0; x < totalKeys; x++) {
           keyList[x] = eval("keyItem" + x);
           var menuItem = document.getElementById( keyList[x].id );
          // var keyElement = document.getElementById( keyList[x].id + ":key" );

           menuItem.setAttribute("accesskey",keyList[x].accesskey);
           menuItem.setAttribute("acceltext",keyList[x].acceltext);
           //keyElement.setAttribute("key",keyList[x].key);
           //keyElement.setAttribute("modifiers","");
       }
   } catch(e) {
       dump(e+"error in buildui.js in buildMenuKeyBindings()\n");
   }
}

