// author: Mark Bokil
// version: 0.1.1
// date: 10/15/03


// main global variables/references
var isLoaded = null;
var content;
var contentCopy;
var Browser;
var console;
var command;
var splitter;
var commandLine;
var inputFile;
var mainWindow;
var status;
var properties;
var documentHistory;
var bufferList;
var buffer;
var windowType="";
var tempFiles = new Array();
var fontFace;
var fontSize;
var fontWeight;
var fontColor;
var fontWeight;
var refreshTimeout;

// this is a hack since chromes in tabs call onload more than once
function preload() {
    if (isLoaded == null) {
        isLoaded = 1;
        runMain();
    }
    return;
}


function runMain() {
    // handle JS errors
    // turn off before deploying or JS console will not work
    //window.onerror=dumperror;

    // enable/disable dumping to console
    // arguments: true, false
    doDump(false);

    // turn on javascript error dumping
    dump("***********************************\n");
    dump("Starting up Mozedit Application...\n");
    dump("***********************************\n\n");

    //include external libraries in JSLIB
    include("chrome://mozedit/content/io/file.js");
    include("chrome://mozedit/content/io/fileUtils.js");
    include("chrome://mozedit/content/io/dirUtils.js");
    include("chrome://mozedit/content/io/dir.js");

    // commands for goDoCommand
    include("chrome://global/content/globalOverlay.js");
    //mozedit include library files
    include("chrome://mozedit/content/scripts/utility.js");
    include("chrome://mozedit/content/scripts/buffer.js");
    include("chrome://mozedit/content/scripts/io.js");
    include("chrome://mozedit/content/scripts/editingfunctions.js");
    include("chrome://mozedit/content/scripts/clipboard.js");
    include("chrome://mozedit/content/scripts/tabs.js");
    include("chrome://mozedit/content/scripts/buildui.js");
    include("chrome://mozedit/content/scripts/properties.js")
    include("chrome://mozedit/content/scripts/windowdialog.js")
    include("chrome://mozedit/content/scripts/emacscommands.js")

    // windowdialog.js, history.js

    // status bar
    status = document.getElementById('status');

    // browser is rendering area in app
    browser = document.getElementById('browser-preview');

    // browser is rendering area in app
    console = document.getElementById('javascript-console')

    splitter = document.getElementById('browser-splitter');

    sidebar = document.getElementById('mozedit-sidebar');

    // center window on
    //centerWindowOnScreen();

    // document history object
    documentHistory = new Array();

    // restore properties
    doProperties();
    var bundle_state = getBundle();
    if (bundle_state == false) {
        restoreDefaults();
    }

    // content is the main text editing area
    buildEditor();
    content = document.getElementById('content-editor');
    inputFile = document.getElementById('file-input');
    command = document.getElementById('command-line');
    getHistory();
    buildGoMenu();
    buildMenuKeyBindings();
    buildViewMenuChecks();
    restoreUIPrefs();

    // set up buffers
    buffer = new Buffer();
    bufferList = new BufferList();
    bufferList.addBuffer( buffer );
    buildBufferMenu();

    //add a tab to tab-bar
    addTab();
    setWindowTitle();

    // set focus to input field
    inputFile.focus();

    // check if mozedit was opened from Firebird
    doEditInMozedit();
    doWelcomeMessage();
}


function doWelcomeMessage() {
    if ( editorBindings != "editordefault" ) {
       updateStatus("Emacs keybindings enabled.");
   } else {
       updateStatus("Default keybindings enabled.");
   }
}


function restoreDefaults() {
    fontFace = "courier";
    fontSize = 10;
    fontWeight = "normal";
    fontColor = "black";
    fontWeight = "normal";
    backgroundColor = "white";
    historyMax = 25;
    isBackupEnabled = "true";
    isSaveNagEnabled = "true";
    isOpenNewDocumentEnabled = "true";
    isModified = false;
    editorBindings = "editordefault";
    documentType = "html";
    isAlternateSourceEnabled = "false";
    isBrowserPreviewEnabled = "true";
    isTimedRefreshEnabled = "false";
    isActivityIndicatorEnabled = "true";
    timedRefreshFrequency = 4;
    alternateBrowserSource = "";
    refreshTimeout = "";
    tabSize = 2;
    isCssEnabled = "false";
}


function dumperror(msg, url, linenumber){
    dump('Javascript Error message= '+msg+'\nURL= '+url+'\nLine Number= '+linenumber+'\n')
    return true;
}


function doEditInMozedit() {
    // tabs and sidebar use window.location
    // windows use window.arguments
    var file = new String(window.location);

    if (file.indexOf("sidebar") != -1) {
        windowType="sidebar";
        var popUp = document.getElementById('menu-file-popup');
        var child = document.getElementById('menu-file-quit');
        var menuSeparator = document.getElementById('menu-file-quit-separator');
        remnant = popUp.removeChild(child);
        remnant = popUp.removeChild(menuSeparator);
    }

    try {
        if (file.search(/url=/i) == -1) {
        file = window.arguments[0].url;
    } else {
        var position = file.indexOf("=");
        file = file.substring( position+1, file.length );
    }
    } catch(e) {
        dump(e+ "error in mozedit.js:doEditInMozedit\n");
        return;
    }

    if (file != null && file !="" && file !="about:blank" && file.indexOf("file:") != -1) {
        if (navigator.platform == "Win32") {
            file = decodeURI(file);
            file = file.replace(/\//g,"\\");
            file = file.replace(/file:\\\\\\/g,"");
        }
        openFile(file);
    }
}



function doRefreshTimer() {
    refreshTimeout = setTimeout("refreshPreview();doRefreshTimer();", 1000 * timedRefreshFrequency);
}

function killRefreshTimer() {
    clearTimeout( refreshTimeout );
}


function showHide(viewControl, menuItem) {
    view = document.getElementById(viewControl);

    if ( view.getAttribute('collapsed').search('false') != -1 ) {
        view.setAttribute('collapsed','true');
        menuItem.setAttribute('checked','false');
    } else {
        view.setAttribute('collapsed','false');
        menuItem.setAttribute('checked','true');
        if (viewControl == "addressbar") {
            inputFile.focus();
        }
        if (viewControl == "execute-command") {
            command.focus();
        }
    }
}


function toggleMozeditSidebar() {
    var sidebar = document.getElementById('mozedit-sidebar');
    var splitter = document.getElementById('splitter-sidebar');

    if ( sidebar.getAttribute('hidden').indexOf("true") != -1 ) {
       sidebar.setAttribute('hidden','false');
       splitter.setAttribute('hidden','false');
       doFunctionsList();
    } else {
       sidebar.setAttribute('hidden','true');
       splitter.setAttribute('hidden','true');
    }
}


function refreshSidebar() {
    if (document.getElementById('mozedit-sidebar').getAttribute('hidden').search('false') != -1) {
        doFunctionsList();
    }
}

function doFunctionsList() {
  var functionList = new Array();
  var lines = content.value.split("\n");

    for (x=0; x < lines.length; x++) {
         var pattern = new RegExp("function +\(.*\)\s*","i");
        if ( lines[x].search(pattern) != -1 ) {
            functionList.push( trim(lines[x]) );
        }
    }
    functionList.sort();

   var box = document.getElementById('mozedit-sidebar');
   var list = document.getElementById('functions-list');

   if (list != null) {
       box.removeChild(list);
   }

    var newList = document.createElement('listbox');
    //id="functions-list" class="field" style="width:200px;" flex="0"
    newList.setAttribute('id','functions-list');
    newList.setAttribute('class','field');
    newList.setAttribute('width','150px');
    newList.setAttribute('flex','1');
    box.appendChild(newList);
    list = document.getElementById('functions-list');

    if (content.value == "") {
        return;
    }
    
    for (x=0; x < functionList.length; x++) {
      var item = document.createElement('listitem');
      var itemName = trim(functionList[x]);
      var itemSearch = trim(functionList[x]);

      itemName = itemName.replace(/function /,"");
      itemName = itemName.replace(/{/,"");
      item.setAttribute('id','sidebar-item'+x);
      item.setAttribute('label',itemName);
      item.setAttribute('onmouseup',"scrollTo('" + "function "+itemName+ "')");
      list.appendChild(item);
    }
}



function toggleMenuCheckbox() {
    // check menu items
    current_state = menuitem.getAttribute("checked");
    if (current_state == true) {
        menuitem.setAttribute('checked','false');
    } else {
        menuitem.setAttribute('checked','true');
    }
}


function setAutoBackup(enabled) {
    this.isAutoBackupEnabled = enabled;
    contentCopy = content.value;

    content.value = "";
    restoreUIPrefs();
    content.value = contentCopy;
    contentCopy = null;
}


// run a program entered on command line
function runProgram() {
    var commandStr = trim( command.value );
    if ( commandStr != "") {
        try {
            fu = new FileUtils();
            var path = new Array();
            path = commandStr.split(" ");

            if (path.length == 1) {
                var result = fu.spawn(path[0]);
            }
            if (path.length > 1) {
                var program = path[0];

                var argument = path[1];

                if (argument.search(/\$s/i) != -1) {
                    argument = trim(inputFile.value);
                }
                argument = new Array(argument);
                var result = fu.spawn( program, argument );

            }

            if (result != null) {
                updateStatus("Program executed successfully...");
                return true;
            } else {
                updateStatus("Program execution failed...");
                return false;
            }
        } catch(e) {
            updateStatus("Program could not be run...");
            dump(e + "error in runProgram()\n");
        }
    }
}


// dump send output to STDOUT terminal
function doDump(isEnabled) {
    const PREFS_CID    = "@mozilla.org/preferences;1";
	const PREFS_I_PREF = "nsIPref";
	const PREF_STRING  = "browser.dom.window.dump.enabled";

	try {
	    var Pref = new Components.Constructor(PREFS_CID, PREFS_I_PREF);
		var pref = new Pref();
		pref.SetBoolPref(PREF_STRING, isEnabled);
	} catch(e) {}
}


function setWindowTitle(path) {
    if (path == null || path == "") {
        window.title = BufferList.currentBuffer + " Untitled";
    } else {
        window.title = BufferList.currentBuffer + " " + truncate(path);
    }
}


// switch document buffers -- document menu
function doBuff(id) {
    if ( id == BufferList.currentBuffer ) {
        return true;
    }

    buffer.saveBuffer(content.value, inputFile.value);
    buffer = bufferList.getBuffer(id);
    var modified = buffer.getIsChanged();
    content.value = buffer.getContent();
    setModifiedState( modified );
    inputFile.value = buffer.getInput();
    BufferList.currentBuffer = id;
    focusTab(id)
    setWindowTitle(truncate(inputFile.value));
    refreshPreview();
    refreshSidebar();
    dump("current buffer in doBuff(): "+BufferList.currentBuffer+"\n");
}


function goNextTab() {
    if (BufferList.list.length == 1) {
        return;
    }

    if (BufferList.currentBuffer < BufferList.list.length-1) {
        doBuff(BufferList.currentBuffer+1);
    } else {
        doBuff(0);
    }
}


function goPreviousTab() {
    if (BufferList.list.length == 1) {
        return;
    }

    if (BufferList.currentBuffer > 0) {
        doBuff(BufferList.currentBuffer-1);
    } else {
        doBuff(BufferList.list.length-1);
    }
}


// restore UI preferences
function restoreUIPrefs() {
    setViewStyle(content);
    setViewStyle(inputFile);
    setViewStyle(command);
    setViewStyle(sidebar);
}


function setViewStyle(view) {
    view.setAttribute('style',
        'font-size:'+ fontSize+
        'pt;font-family:'+fontFace+
        ';color:'+fontColor+
        ';background-color:'+backgroundColor+
        ';font-weight:'+fontWeight);
}


// clear history
function clearHistory() {
    var menuPopup = document.getElementById('menu-go-popup');

    for ( x = 0; x < documentHistory.length+1; x++) {
	    try {
	        var currentChild = document.getElementById( "menu-go-item"+x);
            throwaway_node = menuPopup.removeChild( currentChild );
		} catch (e) {
		    dump("error in modifying nodes in clearHistory()\n");
		}
	}
   documentHistory = new Array();
   saveHistory();
}


// add file to history menu
function addToHistory(path) {
    if ( path != null ) {
        if ( !searchArray(path,documentHistory) ) {
            appendGoMenu(path);
		    saveHistory();
	  }
	}
}


function setHistorySize(size) {
    this.historyMax = size;
}


// changes font size of text area
function setAutoBackup(enabled) {
    this.isBackupEnabled = enabled;
}


// changes font size of text area
function setSaveNag(enabled) {
    this.isSaveNagEnabled = enabled;
}


// center window on screen
function centerWindowOnScreen(dialogWidth) {
    width = screenX + (document.width - dialogWidth) * .5;
    height = screenY + 130;

    return width;
}


// sets isModified to true when file changes
function setModifiedState(state) {
    buffer.setIsChanged(state);
    //alert( state);
    dump("content changed\n");
}


function handleClose() {
    if ( isSaveNagEnabled == "false" ) {
        removeTempFile();
        window.close();
        return true;
    }

    if (checkAllBuffersForChange() == false) {
        return false;
    }
    removeTempFile();
    window.close();
}

function checkAllBuffersForChange() {
 buffer.saveBuffer(content.value,inputFile.value);
    for (n = bufferList.getLength()-1; n >= 0; n--) {
        tempBuffer = bufferList.getBuffer(n);
        if (trim(tempBuffer.getContent()) == "") {
            continue;
        }
        if ( tempBuffer.getIsChanged() == true ) {
            doBuff(n);
            if (doSaveConfirmation() == false) {
                return false;
            }
        }
    }
}

function addToTempFiles(path) {
    if ( !searchArray(path,tempFiles) ) {
        tempFiles.push(path);
    }
}

function removeTempFile() {
    for (x=0; x < tempFiles.length; x++) {
        try {
            var f = new File(tempFiles[x]);
            var fu = new FileUtils();

            if ( f.isFile) {
                fu.remove(tempFiles[x]);
            }
        } catch(e) {
            dump(e+" temp file could not be removed in handleClose()\n");
        }
    }
}


// closes app window
function doSaveConfirmation() {
    var msg = "\nYour file: \"" + truncate(inputFile.value) + "\"\nhas not been saved yet. Save it now?";

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);

    var flags=promptService.BUTTON_TITLE_SAVE * promptService.BUTTON_POS_0 +
            promptService.BUTTON_TITLE_DONT_SAVE * promptService.BUTTON_POS_2 +
            promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1;

    var result = promptService.confirmEx(window,"Save files?", msg,
    flags, null, null, null, null, {});

    if (result == 0) { //save file
        if (inputFile.value != "") {
            return save();
        } else {
            return saveFilePicker(1);
        }
    }
    if (result == 2) { //don't save
        return true;
    }
    return false; //cancel
}


// updates status bar at bottom of app window
function updateStatus(updateMsg) {
    status.value = "";
    status.value = "Status: " + updateMsg;
}


function hideThrobber() {
    var throbber = document.getElementById("throbber-box");
    throbber.setAttribute('hidden','true');
}


function doThrobber() {
    if ( isActivityIndicatorEnabled == "true") {
        var throbber = document.getElementById("throbber-box");

        throbber.setAttribute('hidden','false');
        var throbberTimer = setTimeout("hideThrobber();", 1000);
    }
}


// refresh browser area pane
function togglePreview(isEnabled) {
    if (isEnabled != null && isEnabled == true) {
        browser.setAttribute('collapsed','false');
        splitter.setAttribute('collapsed','false');
        refreshPreview();
        return;
    }

    if ( browser.getAttribute('collapsed').search('false') != -1 ) {
        splitter.setAttribute('collapsed','true');
        browser.setAttribute('collapsed','true');
    } else {
        splitter.setAttribute('collapsed','false');
        browser.setAttribute('collapsed','false');
    }
    refreshPreview();
}


// refresh preview
function refreshPreview() {
    if (inputFile.value.search(/about:mozedit/) != -1) {
        var string = "<html><head><style>html {background:maroon;color:white;font-style: italic;font-family: serif;}em {font-size: 1.3em;line-height: 0;} #moztext {margin-top: 15%;font-size: 1.1em;text-align: center;line-height: 1.5;} #from {font-size:1.95em;text-align:right;}</style></head><body><p id='moztext'>My God, <em>Soylent Green</em> is made of <em>people!</em></p><p id='from'>from <strong>The Book of Mozedit</strong> 10:16</p></body></html>";
    } else {
        string = content.value;
    }
    if ( refreshPreviewLogic() == true ) {
        return;
    }
    doThrobber();
    browserFrame = window.frames[0].document;
    browserFrame.open();
    browserFrame.write(string);
    browserFrame.close();
}


// refresh preview business logic
function refreshPreviewLogic() {
    var url = trim(inputFile.value);

    if (url == "") {
        return false;
    }

    if (url.search(/about:mozedit/) != -1) {
        return false;
    }

    if (isBrowserPreviewEnabled != "true") {
        updateStatus("Browser preview is currently disabled. Enable in Options.");
        return true;
    }


    if ( isAlternateSourceEnabled == "true" ) {
        if (alternateBrowserSource != "") {
            doThrobber();
            url = alternateBrowserSource;
            if (url.search("http") == -1 ) {
                url = "file://" + url;
            }
            browser.setAttribute('src','about:blank');
            browser.setAttribute('src',url);
            return true;
        }
    }

    if (browser.getAttribute('collapsed').search('false') != -1) {
        try {
            var fu = new FileUtils();
            var path = fu.parent(inputFile.value);
        } catch(e) {
            dump(e+"error in refreshLogic(): near FileUtils\n");
            return false;
        }

        if (navigator.platform == "Win32") {
            path = path.replace(/\//g,"\\");
            path = path + "\\mozedit-temp~";
        } else {
            path = path + "/mozedit-temp~";
        }

        var result = saveLogic(path);

        if (result == true) {
            addToTempFiles(path);
            doThrobber();
            url = 'file://' + path;
            browser.setAttribute('src','about:blank');
            browser.setAttribute('src',url);
            return true;
        } else {
            return false;
        }
    }
}


function viewInBrowser() {
   // add check to see if file exists
    if (trim(inputFile.value) != "") {
        var url = inputFile.value;


        if (navigator.platform == "Win32") {
            url = url.replace(/\\/g,"/");
        }

        url = encodeURI( url );
        if (url.search(/file:/) != -1) {
            window.open(url);
        } else {
            window.open("file://"+url);
        }
    } else {
        alert("Save your file first before viewing in the external browser.");
    }
}


// hide/show JS Console pane
function toggleConsole(isEnabled) {
    var splitterConsole = document.getElementById('splitter-console');

    if (isEnabled != null && isEnabled == true) {
        splitterConsole.setAttribute('collapsed','false');
        console.setAttribute('collapsed','false');
        return;
    }

	if ( console.getAttribute('collapsed').search('false') != -1 ) {
	    splitterConsole.setAttribute('collapsed','true');
	    console.setAttribute('collapsed','true');
	} else {
	    splitterConsole.setAttribute('collapsed','false');
	    console.setAttribute('collapsed','false');
	}

}

// hide/show Symbols
function toggleSymbols(isEnabled) {
    var splitterSymbols = document.getElementById('splitter-symbols');
    var symbols = document.getElementById('symbols');


	if ( symbols.getAttribute('collapsed').search('false') != -1 ) {
	    splitterSymbols.setAttribute('collapsed','true');
	    symbols.setAttribute('collapsed','true');
	} else {
	    splitterSymbols.setAttribute('collapsed','false');
	    symbols.setAttribute('collapsed','false');
	}

}


// get count of lines
function getLineCount() {
    var count = 0;
	var text = content.value;

    for (var x=0; x < text.length; x++) {
	    if (text.charCodeAt(x) == 10) { //10 is newline char
		    count++;
		}
	}
	count++;
	text = null;
    updateStatus("Line count: "+count);
}


function revert() {
    if (contentCopy != null && contentCopy != "") {
	    content.value = contentCopy;
	    contentCopy = null;
        updateStatus("Reverted operation...");
     } else {
	     updateStatus("Revert unavailable...");
     }
}



// goto files section
function goToURL(path) {
    path = decodeURI(path);
    openFile(path);
}

function goChrome() {
 var f = new FileUtils();
    var du = new DirUtils();
    var unixPath = "/chrome/userChrome.css";
    var winPath = "\\chrome\\userChrome.css";
    var path = unixPath;

    if (navigator.platform == "Win32") {
	    path = winPath;
    }
	try {
         var homePath = du.getMozUserHomeDir();
         path = homePath + path;

	     if (! openFile(path) ) {
             if ( confirm("Would you like Mozedit to attempt to install your userChrome.css file? ") ) {
                 content.value = "/*\n"+
"* This file can be used to customize the look of Mozilla's user interface\n"+
"* You should consider using !important on rules which you want to\n"+
"* override default settings.\n"+
"*/\n\n"+

"/*\n"+
"* Do not remove the @namespace line -- it's required for correct functioning\n"+
"*/\n"+
"@namespace url(\"http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul\");\n"+
"/* set default namespace to XUL */\n\n"+
"/* For a list of tips and tweaks visit http://texturizer.net/firebird/tips.html */\n\n";
                 save(path);
             }
         }
	} catch (e) {
	    dump("userChrome.css could not be opened in goChrome()\n"+e);
		return false;
	}
	return true;
}


function goContent() {
 var f = new FileUtils();
    var du = new DirUtils();
    var unixPath = "/chrome/userContent.css";
    var winPath = "\\chrome\\userContent.css";
    var path = unixPath;

    if (navigator.platform == "Win32") {
	    path = winPath;
    }
	try {
         var homePath = du.getMozUserHomeDir();
         path = homePath + path;

	     if (! openFile(path) ) {
             if ( confirm("Would you like Mozedit to attempt to install your userContent.css file? ") ) {
                 content.value = "/*\n"+
"* Edit this file and copy it as userContent.css into your\n"+
"* profile-directory/chrome/\n"+
"*/\n\n"+

"/*\n"+
"* This file can be used to apply a style to all web pages you view\n"+
"* Rules without !important are overruled by author rules if the\n"+
"* author sets any.  Rules with !important overrule author rules.\n"+
"*/\n\n"+
"/* For a list of tips and tweaks visit http://texturizer.net/firebird/tips.html */\n\n";
                 save(path);
             }
         }
	} catch (e) {
	    dump("userContent.css could not be opened in goContent()\n"+e);
		return false;
	}
	return true;
}

function goUser() {
 var f = new FileUtils();
    var du = new DirUtils();
    var unixPath = "/chrome/user.js";
    var winPath = "\\chrome\\user.js";
    var path = unixPath;

    if (navigator.platform == "Win32") {
	    path = winPath;
    }
	try {
         var homePath = du.getMozUserHomeDir();
         path = homePath + path;

	     if (! openFile(path) ) {
             if ( confirm("Would you like Mozedit to attempt to install your user.js preferences file? ") ) {
                 content.value = "// user.js preferences\n" +
                     "// For a list of preferences visit http://texturizer.net/firebird/tips.html\n";
                 save(path);
             }
         }
	} catch (e) {
	    dump("user.js could not be opened in goUser()\n"+e);
		return false;
	}
	return true;
}
