// properties.js



// setup application property files
function doProperties() {
    var du = new DirUtils();
    var pathMozedit = "/chrome/mozeditproperties";
    var propertiesFile = "/mozedit.properties";
    var historyFile = "/history.properties";

    if (navigator.platform == "Win32") {
        pathMozedit = "\\chrome\\mozeditproperties";
        propertiesFile = "\\mozedit.properties";
        historyFile = "\\history.properties";
    }

    try {
         var homePath = du.getMozUserHomeDir();
         var d = new Dir(homePath + pathMozedit);

         if ( !d.exists() ) {
             d.create(0775);
             dump("new mozeditproperties directory in doProperties created\n");
         }
         if ( !d.exists() ) {
             dump("could not write mozilla directory in doProperties\n");
             return false;
         }

         //write propery files
         var fProperties = new File(homePath + pathMozedit + propertiesFile);
         var fHistory = new File(homePath + pathMozedit + historyFile);

         if (!fProperties.exists() ) {
             fProperties.create();
         }

         if (!fHistory.exists() ) {
             fHistory.create();
         }

         if ( !fProperties.exists() && !fHistory.exists() ) {
             dump("could not write property files in doProperties\n")
             return false;
         }
         return true;
    } catch(e) {
        dump(e+ " error occured in doProperties\n");
        return false;
    }
}


// get properties value from keyword
function getProperty(keyword) {
    for (x=0; x < properties.length; x++) {
        if ( properties[x].indexOf(keyword) != -1 ) {
		    var position = properties[x].indexOf("=");
			var value = properties[x].substring( position+1, properties[x].length );
			return value;
		}
	}

}


// save properties file
 function saveProps() {
     var propStr = "";
         propStr = propStr + "font.face=" + fontFace + "\n";
         propStr = propStr + "font.size=" + fontSize + "\n";
         propStr = propStr + "font.color=" + fontColor + "\n";
         propStr = propStr + "font.weight=" + fontWeight + "\n";
         propStr = propStr + "font.background=" + backgroundColor + "\n";
         propStr = propStr + "application.autobackup=" + isBackupEnabled + "\n";
         propStr = propStr + "application.savenag=" + isSaveNagEnabled + "\n";
         propStr = propStr + "application.opendocument=" + isOpenNewDocumentEnabled + "\n";
         propStr = propStr + "application.historymaxlength=" + historyMax + "\n";
         propStr = propStr + "application.editorbindings=" + editorBindings + "\n";
         propStr = propStr + "application.alternatebrowsersource=" + alternateBrowserSource + "\n";
         propStr = propStr + "application.alternatesourcestate=" + isAlternateSourceEnabled + "\n";
         propStr = propStr + "application.browserpreviewstate=" + isBrowserPreviewEnabled + "\n";
         propStr = propStr + "application.activityindicatorstate=" + isActivityIndicatorEnabled + "\n";
         propStr = propStr + "application.documenttype=" + documentType + "\n";
         propStr = propStr + "application.cssstate=" + isCssEnabled + "\n";
         propStr = propStr + "application.tabsize=" + tabSize + "\n";
         propStr = propStr + "application.refreshrate=" + timedRefreshFrequency + "\n";

     if (navigator.platform == "Win32") {
         propStr = propStr.replace(/\//g,"\\");
     }
     try {
         var du = new DirUtils();
         var unixPath = "/chrome/mozeditproperties/mozedit.properties";
         var winPath = "\\chrome\\mozeditproperties\\mozedit.properties";
         var path = unixPath;

         if (navigator.platform == "Win32") {
             path = winPath;
         }

         path = du.getMozUserHomeDir() + path;
         var f = new File(path);

         if (f.exists()) {
             f.open('w');
             f.write(propStr);
             f.close();
             doThrobber();
             updateStatus("Properties saved...");
         } else {
             f.create();
             if (f.exists()) {
             f.open('w');
             f.write(propStr);
             doThrobber();
             updateStatus("Properties saved...");
             } else {
             dump("props could not be saved");
             return false;
             }
             f.close();
         }
    } catch(e) {
        dump(e + " error occured in saveProps()");
        return false;
    }
    return true;
}



//loads in properties bundle
function getBundle() {
    var du = new DirUtils();
    var unixPath = "/chrome/mozeditproperties/mozedit.properties";
    var winPath = "\\chrome\\mozeditproperties\\mozedit.properties";
    var path = unixPath;

    if (navigator.platform == "Win32") {
        path = winPath;
    }

    try {
        path = du.getMozUserHomeDir() + path;
        var f = new File(path);

        if (f.exists()) {
            f.open();
            var bundle = f.read();
            properties = bundle.split("\n");
            f.close();

            if (bundle == "") {
                dump("bundle is empty in getBundle\n");
                return false;
            }

            fontFace = getProperty("font.face");
            fontSize = getProperty("font.size");
            fontColor = getProperty("font.color");
            fontWeight = getProperty("font.weight");
            backgroundColor = getProperty("font.background");
            isSaveNagEnabled = getProperty("application.savenag");
            isBackupEnabled = getProperty("application.autobackup");
            isOpenNewDocumentEnabled = getProperty("application.opendocument");
            historyMax = getProperty("application.historymaxlength");
            editorBindings = getProperty("application.editorbindings");
            alternateBrowserSource = getProperty("application.alternatebrowsersource");
            isAlternateSourceEnabled = getProperty("application.alternatesourcestate");;
            isBrowserPreviewEnabled = getProperty("application.browserpreviewstate");
            isActivityIndicatorEnabled = getProperty("application.activityindicatorstate");
            documentType = getProperty("application.documenttype");
            isCssEnabled = getProperty("application.cssstate");
            tabSize = getProperty("application.tabsize");
            timedRefreshFrequency = getProperty("application.refreshrate");
            if (fontFace == null || fontSize == null || fontColor == null || fontWeight == null || tabSize == null || timedRefreshFrequency == null) {
                return false;
            }
        } else {
            dump("properties file could not be opened in getBundle();\n");
            return false;
        }
    } catch(e) {
        dump(e + "error in getBundle\n");
        return false;
    }
    return true;
}


// save history file
function saveHistory() {
    var propStr = "";
	var du = new DirUtils();
    var unixPath = "/chrome/mozeditproperties/history.properties";
    var winPath = "\\chrome\\mozeditproperties\\history.properties";
    var path = unixPath;

	if (navigator.platform == "Win32") {
	    path = winPath;
    }

	path = du.getMozUserHomeDir() + path;
    var f = new File(path);

	for (x = 0; x < documentHistory.length; x++) {
	    var historyItem = documentHistory[x];
		if (historyItem == "") {
		    continue;
		}
        propStr = propStr + historyItem + "\n";
        if (navigator.platform == "Win32") {
            propStr = propStr.replace(/\//g,"\\");
        }
    }

    // need at least one char to write to file
    if (propStr == "") {
        propStr = " ";
    }
    if ( f.exists() ) {
       try {
           f.open('w');
	       f.write(propStr);
	       f.close();
           doThrobber();
           dump("writing history in saveHistory()\n");
	   } catch(e) {
	       dump(e +"error in saveHistory()\n");
           return false;
	   }
	   updateStatus("History saved...");
   } else {
       try {
       f.create();
	   if (f.exists()) {
	       f.open('w');
	       f.write(propStr);
           f.close();
           doThrobber();
	       updateStatus("History saved...");
	   } else {
	       dump("History could not be saved in saveHistory()\n")
	   }
       } catch(e) {
           dump(e+"error occured in saveHistory()\n");
           return false;
       }
   }
}


// loads in bundle from history
function getHistory() {
    var du = new DirUtils();
    var unixPath = "/chrome/mozeditproperties/history.properties";
    var winPath = "\\chrome\\mozeditproperties\\history.properties";
    var path = unixPath;

    if (navigator.platform == "Win32") {
          path = winPath
    }

    try {
        path = du.getMozUserHomeDir() + path;
        dump("user home dir from getHistory() \n"+ path);
        var f = new File(path);

        if (f.exists()) {
            f.open();
            var bundle = f.read();
            f.close();
            documentHistory = bundle.split("\n");
            // check for trailing empty history items and pop them off
            if (documentHistory.length > 0) {
                if ( trim(documentHistory[documentHistory.length-1]) == "" ) {
                    documentHistory.pop();
                }
            }
        } else {
            dump("history file could not be opened in getHistory();\n");
        }
     } catch(e) {
        dump(e+"error in getHistory()");
        return false;
    }
}

